<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier3 extends AbstractStructArrayBase
{
    /**
     * The InternalVisaSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalVisaSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier3
     * @uses ArrayOfJP_InternalSupplier3::setInternalVisaSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalVisaSupplier
     */
    public function __construct(array $internalVisaSupplier = array())
    {
        $this
            ->setInternalVisaSupplier($internalVisaSupplier);
    }
    /**
     * Get InternalVisaSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalVisaSupplier()
    {
        return $this->InternalVisaSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setInternalVisaSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInternalVisaSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInternalVisaSupplierForArrayConstraintsFromSetInternalVisaSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InternalSupplier3InternalVisaSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplier3InternalVisaSupplierItem instanceof \StructType\JP_InternalSupplier) {
                $invalidValues[] = is_object($arrayOfJP_InternalSupplier3InternalVisaSupplierItem) ? get_class($arrayOfJP_InternalSupplier3InternalVisaSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_InternalSupplier3InternalVisaSupplierItem), var_export($arrayOfJP_InternalSupplier3InternalVisaSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InternalVisaSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InternalVisaSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalVisaSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier3
     */
    public function setInternalVisaSupplier(array $internalVisaSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($internalVisaSupplierArrayErrorMessage = self::validateInternalVisaSupplierForArrayConstraintsFromSetInternalVisaSupplier($internalVisaSupplier))) {
            throw new \InvalidArgumentException($internalVisaSupplierArrayErrorMessage, __LINE__);
        }
        $this->InternalVisaSupplier = $internalVisaSupplier;
        return $this;
    }
    /**
     * Add item to InternalVisaSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier3
     */
    public function addToInternalVisaSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalVisaSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InternalVisaSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalVisaSupplier
     */
    public function getAttributeName()
    {
        return 'InternalVisaSupplier';
    }
}
